/* Anti Web HTTPD */
/* HardCore Software */
/*
This software us Copyright (C) 2001 By HardCore Software.
The software is distributed under the terms of the GNU General Public
License. See the file 'LICENSE' for more details.
*/



/* FUNCTION PROTOTYPES */

/* misc.c functions */
void discon(int i);
void die();
void nada();
void verifyconnsperip(int i);
void verifytimeconnected();
void parsecnfdir();
int isadir(char *tpbuf);
void status();
void usage();
int isacgifile(char *thefile);
int doesfileexist(char *tpbuf);
long flength(char *fname);
void senddata(int thesock, char *tpbuf);
void sendcontenttype(int i, char *cbuf);
static char* get_mime_type(char* name);
void stripcrlf(char *buf);
void serverinit();

/* procin.c functions */
int processincoming(int i, char *buf);
int processgetreq(int i, char *buf);

/* procout.c fucntions */
void processoutgoing(int i);
void send301(int i, char *tpbuf);
void send404(int i);
void send403(int thesock, int reason);

/* procscrpt.c functions */
void initscript(int i);
void processscript(int i);

/* proclog.c functions */
void logthis(int priority, char *buf);

/* urldecode.c functions */
static int hexit(char c);
void urldecode(char *buf);



/* CONSTANTS */
/* You can thank Zas (zas@norz.org) for this idea. It not only makes the
   code much easier to read, but it may contribute to portability as well.
   In case you want to run AW on an IBM 360 using EBCIDIC. Whatever.
*/


#define SLASH '/'
#define POINT '.'
#define SPACE ' '
#define LF 10
#define CR 13




/* CONFIG.H SANITY CHECKING */

#ifndef STARTFILE
  #define STARTFILE "index.html"
#endif

#ifndef INDEXFILE
  #define INDEXFILE "index.html"
#endif

#ifndef COOLQUOTE
  #define COOLQUOTE "Fear and loathing on the WWW"
#endif

#ifndef BACKLOG
  #define BACKLOG 10
#endif

#ifndef MAXDATASIZE
  #define MAXDATASIZE 1000
#endif

#ifndef MAXUSERS
  #define MAXUSERS 100
#endif

#ifndef MAXCONNSPERIP
  #define MAXCONNSPERIP 5
#endif

#ifndef USERTIMEOUT
  #define USERTIMEOUT 5
#endif

#ifndef MAXGETREQSIZE
  #define MAXGETREQSIZE 100
#endif

#ifndef MAXROOTDIRSIZE
  #define MAXROOTDIRSIZE 100
#endif

#ifndef SELECTTIMEOUT
  #define SELECTTIMEOUT 10000
#endif

#ifndef MTU
  #define MTU 5000
#endif

#ifndef HIDEFILESSTARTINGWITHADOT
  #define HIDEFILESSTARTINGWITHADOT 1
#endif

#ifndef VERSION
  #define VERSION "?.?"
#endif

#ifndef CHARSET
  #define CHARSET "iso-8859-1"
#endif



/* Removes the features necessary to cripple Anti-Web for Windows */
#ifdef WINDOWS
  #undef LOGLEVEL
  #undef UIDTORUNAS
#endif
